import { loadEnv } from 'vite';
import { randomBytes } from 'crypto';
import { appendFile } from 'fs/promises';

interface Env {
    JWT_SECRET: string;
    LINK_LENGTH?: number;

    // database
    DB_HOST?: string;
    DB_PORT?: string;
    DB_USER?: string;
    DB_PASS?: string;
    DB_NAME?: string;
}

let env: Record<string, string> = loadEnv("production", ".", "");
if (!env.JWT_SECRET) {
    env.JWT_SECRET = randomBytes(32).toString('hex');
    await appendFile('.env', `

# automatically generated by $lib/env.ts
JWT_SECRET=${env.JWT_SECRET}`);
}

export default env as unknown as Env;